<?php
namespace NicolasBejean\CategoryWidget\Api\Data;

/**
 * Interface CategoryWidgetInterface
 *
 * @category PHP
 * @package  NicolasBejean\CategoryWidget\Api\Data
 * @author   Nicolas Béjean <nicolas@bejean.eu>
 * @license  https://github.com/nicolasbejean/category-widget/blob/master/licence.txt BSD Licence
 * @link     https://www.bejean.eu
 */
interface CategoryWidgetInterface
{
    const ENTITY_ID     = 'entity_id';
    const TITLE         = 'title';
    const IDENTIFIER    = 'identifier';
    const CONTENT       = 'content';
    const IS_ACTIVE     = 'is_active';
    const CREATION_TIME = 'created_at';
    const UPDATE_TIME   = 'updated_at';

    /**
     * Get Category Widget ID
     *
     * @return mixed
     */
    public function getId();

    /**
     * Get Category Widget Title
     *
     * @return mixed
     */
    public function getTitle();

    /**
     * Get Category Widget Identifier
     *
     * @return mixed
     */
    public function getIdentifier();

    /**
     * Get Category Widget Content
     *
     * @return mixed
     */
    public function getContent();

    /**
     * Get Category Widget Creation Time
     *
     * @return mixed
     */
    public function getCreationTime();

    /**
     * Get Category Widget Update Time
     *
     * @return mixed
     */
    public function getUpdateTime();

    /**
     * Get Category Widget Is Active
     *
     * @return mixed
     */
    public function isActive();

    /**
     * Set Category Widget ID
     *
     * @param $id
     * @return mixed
     */
    public function setId($id);

    /**
     * Set Category Widget Title
     *
     * @param $title
     * @return mixed
     */
    public function setTitle($title);

    /**
     * Set Category Widget Identifier
     *
     * @param $identifier
     * @return mixed
     */
    public function setIdentifier($identifier);

    /**
     * Set Category Widget Content
     *
     * @param $content
     * @return mixed
     */
    public function setContent($content);

    /**
     * Set Category Widget Creation Time
     *
     * @param $creationTime
     * @return mixed
     */
    public function setCreationTime($creationTime);

    /**
     * Set Category Widget Update Time
     *
     * @param $updateTime
     * @return mixed
     */
    public function setUpdateTime($updateTime);

    /**
     * Set Category Widget is Active
     *
     * @param $isActive
     * @return mixed
     */
    public function setIsActive($isActive);
}
